{{ ansible_managed | comment(decoration='"') }}
call plug#begin('~/.config/nvim/plugged')
" Plugins will go here in the middle.
Plug 'scrooloose/nerdtree', { 'on':  'NERDTreeToggle' }
Plug 'morhetz/gruvbox'
Plug 'vim-airline/vim-airline'
Plug 'vim-airline/vim-airline-themes'
Plug 'hashivim/vim-terraform'
Plug 'pearofducks/ansible-vim'
Plug 'dyng/ctrlsf.vim'
Plug 'drewtempelmeyer/palenight.vim'
Plug 'martinda/Jenkinsfile-vim-syntax'
Plug 'tangledhelix/vim-kickstart'
Plug 'ekalinin/Dockerfile.vim'
Plug 'sickill/vim-monokai'
Plug 'dracula/vim', { 'as': 'dracula' }
call plug#end()

let mapleader = ","
syntax on
filetype plugin indent on
setglobal modeline
set backupdir=/tmp/
set directory=/tmp/
set path+=**

"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
" => VIM user interface
"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
" colors
set termguicolors
set background=dark
colorscheme monokai
set colorcolumn=79 " show a ruler of 79 width
set number
set relativenumber " show relative line no.
" display all matching files when we tab complete
set wildmenu
" enable horizontal cursorline
set cursorline
" Jump to first search result
set incsearch
" Show 'invisible' characters
set lcs=tab:\ \ ,trail:·,nbsp:_
set list
set magic " For regular expressions turn magic on
set showmatch " Show matching brackets when text indicator is over them
set mat=2 " How many tenths of a second to blink when matching brackets
let NERDTreeShowLineNumbers=1 " Enable line numbers in NERDTree
map <Leader>n :NERDTreeToggle<CR>
" resize vim splits
nnoremap <silent> <Leader>+ :exe "resize " . (winheight(0) * 3/2)<CR>
nnoremap <silent> <Leader>- :exe "resize " . (winheight(0) * 2/3)<CR>

" Ansible / Terraform tweaks
let g:ansible_attribute_highlight = "ob"
let g:ansible_name_highlight = 'd'
let g:terraform_fmt_on_save=1

set ruler " enable ruler
set nocompatible
set rtp+=~/.fzf " set runtimepath for fuzzyfinder
nmap <C-P> :FZF<CR>

" make buffer cycling a lot faster
map <C-right> <ESC>:bn<CR>
map <C-left> <ESC>:bp<CR>
let g:airline#extensions#tabline#enabled = 1
"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
" => Text, tab and indent related
"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
set expandtab " Use spaces instead of tabs

set smarttab " Be smart when using tabs ;)

" 1 tab == 2 spaces
set shiftwidth=2
set tabstop=2
set softtabstop=2

set ai "Auto indent
set si "Smart indent

function! NumberToggle()
  if &relativenumber
    set norelativenumber
    echo "relative number off"
  else
    set relativenumber
    echo "relative number on"
  endif
endfunction
nmap <C-N> :call NumberToggle()<CR>

""""""""""""""""""""""""""""""
" => Status line
""""""""""""""""""""""""""""""
" Always show the status line
set laststatus=2

" Format the status line
set statusline=\ %{HasPaste()}%F%m%r%h\ %w\ \ CWD:\ %r%{getcwd()}%h\ \ \ Line:\ %l

"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
" => Helper functions
"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
" Returns true if paste mode is enabled
function! HasPaste()
  if &paste
    return 'PASTE MODE '
  endif
  return ''
endfunction

function! CommitMessages()
    let g:git_ci_msg_user = substitute(system("git config --get user.name"), '\n$', '', '')
    let g:git_ci_msg_email = substitute(system("git config --get user.email"), '\n$', '', '')

    nmap S oSigned-off-by: <C-R>=printf("%s <%s>", g:git_ci_msg_user, g:git_ci_msg_email)<CR><CR><ESC>
    nmap R oReviewed-by: <C-R>=printf("%s <%s>", g:git_ci_msg_user, g:git_ci_msg_email)<CR><ESC>
    iab #S Signed-off-by: <C-R>=printf("%s <%s>", g:git_ci_msg_user, g:git_ci_msg_email)<CR>
    iab #R Reviewed-by: <C-R>=printf("%s <%s>", g:git_ci_msg_user, g:git_ci_msg_email)<CR>
    iab #O Signed-off-by:
    iab #V Reviewed-by:
    iab #P Pair-Programmed-With:
    iab ME <C-R>=printf("%s <%s>", g:git_ci_msg_user, g:git_ci_msg_email)<CR>
    iab ASN Andreas<SPACE>Schnitzel<SPACE><asn@google.org>
endf
autocmd BufWinEnter COMMIT_EDITMSG,*.diff,*.patch,*.patches.txt call CommitMessages()
